#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <locale.h>

#define ITERATIONS 1000
#define DEFAULT_SIZE 1024

size_t exercise(size_t size, int iterations);
int exercise_init(const char *name, size_t size);
void exercise_free();

size_t get_padded_size(size_t size, size_t block_size) {
    size_t blocks = (size / block_size);
    size_t inc = blocks * block_size - size;
    if (inc) return (blocks + 1) * block_size;
    return size;
}

int main(int argc, char *argv[]) {
    int err;
    long i;
    size_t size = DEFAULT_SIZE;
    size_t iterations = ITERATIONS;
    int standard_memory = 0;
    float *res;
    
    size_t runtime;
    size_t us;
    struct timeval tv1,tv2;

    char *name, fname[255];
    FILE *f;

    name = strrchr(argv[0], '/');
    if (name) name += 1;
    else name = argv[0];

    if (argc > 1) {
        size = atoi(argv[1]);
    }
    
    if (argc > 2) {
	iterations = atoi(argv[2]);
	if (!iterations) iterations = 1;
    }
    
    setlocale(LC_NUMERIC, "en_US");

    err = exercise_init(name, size);
    if (err) return err;

    gettimeofday(&tv1, NULL);
    exercise(size, iterations);
    gettimeofday(&tv2, NULL);

    exercise_free();

    return 0;
}

