__kernel void multiply(__global float *res, __global float *a, __global float *b, unsigned long local_size, __global float *scratch, __local float *shmem) {
    int i;
    float sum = 0;

    int threads = get_global_size(0);
    int pos = get_global_id(0);

    for(i = 0; i < local_size; i++) {
	sum  += a[i * threads + pos] * b[i * threads + pos];
    }

    scratch[pos] = sum;
    
    barrier(CLK_GLOBAL_MEM_FENCE);

    if (pos == 0) {
	for (i = 1; i < threads; i++)
	    sum += scratch[i];

	*res = sum;
    }
}
