#include <stdio.h>
#include <stdlib.h>

#define BLOCK_SIZE 4

int exercise_init(const char *name, size_t size) {
    return 0;
}

int exercise_allocate(float **res, float **a, float **b, size_t size) {
    return 0;
}

void exercise_free() {
}

int exercise_required_alignment = BLOCK_SIZE;



static void exercise_iteration(float *res, float *a, float *b, size_t size) {
    int i, j, i0, j0, k, k0;
    
    #pragma acc kernels present_or_copyin(a[0:size*size],b[0:size*size])  copyout(res[0:size*size])
    {
	#pragma acc loop independent
	for(i = 0; i < size; i += BLOCK_SIZE) {
	    #pragma acc loop independent
	    for(j = 0; j < size; j += BLOCK_SIZE) {

		for (i0 = 0; i0 < BLOCK_SIZE; i0++) {
		    for (j0 = 0; j0 < BLOCK_SIZE; j0++) {
			res[(i + i0) * size + (j + j0)] = 0;
		    }
		}
		
		for(k = 0; k < size; k += BLOCK_SIZE) {
		    for (i0 = 0; i0 < BLOCK_SIZE; i0++) {
			for (j0 = 0; j0 < BLOCK_SIZE; j0++) {
			    for (k0 = 0; k0 < BLOCK_SIZE; k0++) {
				res[(i + i0) * size + (j + j0)] += a[(i + i0) * size + (k + k0)] * b[(k + k0) * size + (j + j0)];
			    }
			}
		    }
		}
	    }
	}
    } 
}

size_t exercise(float *res, float *a, float *b, size_t size, int iterations) {
    long iter;

    for (iter = 0; iter < iterations; iter++) {
	exercise_iteration(res, a, b, size);
    }
    return 0;
}
