#define A(i, j) shmem[(i) * PPT * BLOCK_SIZE + (j)]
#define B(i, j) shmem[PPT * PPT * BLOCK_SIZE * BLOCK_SIZE + (i) * PPT * BLOCK_SIZE + (j)]

__kernel void multiply(__global float *res, __global float *a, __global float *b, unsigned long size, __local float *shmem) {
    float sum[PPT][PPT] = {0};
    
    int tx = get_local_id(0);
    int ty = get_local_id(1);

    int i = get_global_id(1);
    int j = get_global_id(0);

    int x, y;
    int k, l;

    for(k = 0; k < size; k += PPT * BLOCK_SIZE) {
#pragma unroll PPT
	for (y = 0; y < PPT; ++y) {
#pragma unroll PPT
	    for (x = 0; x < PPT; ++x) {
		A(ty * PPT + y, tx * PPT + x) = a[(i * PPT + y) * size + (k + tx * PPT + x)];
		B(ty * PPT + y, tx * PPT + x) = b[(k + ty * PPT + y) * size + (j * PPT + x)];
	    }
	}
	
	barrier(CLK_LOCAL_MEM_FENCE);
	
#pragma unroll PPT * BLOCK_SIZE
	for (l = 0; l < PPT * BLOCK_SIZE; ++l) {
#pragma unroll PPT
	    for (y = 0; y < PPT; ++y) {
#pragma unroll PPT
		for (x = 0; x < PPT; ++x) {
		    sum[y][x]  += A(ty * PPT + y, l) * B(l, tx * PPT + x);
//		    sum[y][x]  += A(ty * PPT + y, l) * b[(k + l) * size + (j * PPT + x)];
//		    sum[y][x]  += a[(i * PPT + y) * size + (k + l)] * b[(k + l) * size + (j * PPT + x)];
		}
	    }
	}

	barrier(CLK_LOCAL_MEM_FENCE);
    }
    
#pragma unroll PPT
	for (y = 0; y < PPT; ++y) {
#pragma unroll PPT
	    for (x = 0; x < PPT; ++x) {
		res[(i * PPT + y) * size + j * PPT + x] = sum[y][x];
	    }
	}
}
