const sampler_t sampler = CLK_NORMALIZED_COORDS_TRUE | CLK_ADDRESS_CLAMP_TO_EDGE | CLK_FILTER_LINEAR;

__kernel void scale(__read_only image2d_t srcImg, __write_only image2d_t dstImg)
{
    float2 src_coord = (float2) (1. * get_global_id(0) / get_global_size(0), 1. * get_global_id(1) / get_global_size(1));
    int2 dst_coord = (int2)(get_global_id(0), get_global_id(1));

    int width = get_image_width(dstImg);
    int height = get_image_height(dstImg);

    if (dst_coord.x < width && dst_coord.y < height) {
        uint4 color = read_imageui(srcImg, sampler, src_coord);
        write_imageui(dstImg, dst_coord, color);
    }
}
