__kernel void transpose(__global float *res, __global float *a, unsigned long size, __local float *shmem) {
    int bx = get_group_id(0) * get_local_size(0);
    int by = get_group_id(1) * get_local_size(1);

    int tx = get_local_id(0);
    int ty = get_local_id(1);

    int x = bx + tx;
    int y = by + ty;

    shmem[ty * get_local_size(0) + tx] = a[y * size + x];

    barrier(CLK_LOCAL_MEM_FENCE);
    
    x = by + tx;
    y = bx + ty;

    res[y  * size + x] = shmem[tx * get_local_size(0) + ty];
}
